#include <cmath>
#include <stdint.h>
#include "utilities.h"

void printInt(sendByteFunction fun, uint16_t value)
{
  uint16_t div = 10000;
  bool firstChar = true;
  while (div) {
    uint8_t digit = value / div;
    value -= digit * div;
    if (firstChar) {
      if (digit || (div == 1)) {
        fun(digit + '0');
        firstChar = false;
      }
    } else {
      fun(digit + '0');
    }
    div /= 10;
  }
}

void printFloat(sendByteFunction fun, float value)
{
  if (value < 0) {
    value = -value;
    fun('-');
  }
  float first = floor(value);
  printInt(fun, uint16_t(first));
  fun('.');
  uint8_t rest = uint16_t((value - first) * 100.0f);
  fun((rest / 10) + '0');
  fun((rest % 10) + '0');
}
